Backend API
$(() => {
const dataGrid = $('#gridContainer').dxDataGrid({
dataSource: orders,
keyExpr: 'ID',
allowColumnReordering: true,
allowColumnResizing: true,
width: '100%',
showBorders: true,
selection: {
mode: 'single',
},
filterRow: {
visible: true,
},
groupPanel: {
visible: true,
},
stateStoring: {
enabled: true,
type: 'localStorage',
storageKey: 'storage',
},
pager: {
visible: true,
showPageSizeSelector: true,
allowedPageSizes: [5, 10, 20],
},
columns: [{
dataField: 'OrderNumber',
width: 130,
caption: 'Invoice Number',
}, {
dataField: 'OrderDate',
dataType: 'date',
sortOrder: 'desc',
}, {
dataField: 'SaleAmount',
alignment: 'right',
format: 'currency',
},
'Employee', {
caption: 'City',
dataField: 'CustomerStoreCity',
}, {
caption: 'State',
dataField: 'CustomerStoreState',
groupIndex: 0,
}],
}).dxDataGrid('instance');
$('#state-reset-link').on('click', () => {
dataGrid.state(null);
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="js/dx.all.js?v=25.1.6"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="descContainer"
>Sort and filter data, group, reorder and resize columns, change page numbers and page size. Once you are done, <a onclick="window.location.reload()">refresh</a> the web page to see that the
grid’s state is automatically persisted to continue working from where you stopped or you can <a id="state-reset-link">reset</a> the grid to its initial state.</div
>
<div id="gridContainer"></div>
</div>
</body>
</html>
#gridContainer {
height: 440px;
margin-top: 30px;
}
#descContainer a {
color: #f05b41;
text-decoration: underline;
cursor: pointer;
}
#descContainer a:hover {
text-decoration: none;
}
const orders = [{
ID: 1,
OrderNumber: 35703,
OrderDate: new Date(2014, 3, 10),
SaleAmount: 11800,
Terms: '15 Days',
TotalAmount: 12175,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: new Date(2014, 0, 12),
SaleAmount: 16050,
Terms: '15 Days',
TotalAmount: 16550,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: new Date(2014, 0, 22),
SaleAmount: 14750,
Terms: '15 Days',
TotalAmount: 15250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: new Date(2014, 1, 7),
SaleAmount: 3725,
Terms: '15 Days',
TotalAmount: 3850,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: new Date(2014, 2, 11),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14800,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: new Date(2014, 2, 1),
SaleAmount: 7800,
Terms: '15 Days',
TotalAmount: 8200,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: new Date(2014, 1, 15),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 9100,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: new Date(2014, 1, 4),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 19100,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: new Date(2014, 1, 15),
SaleAmount: 20400,
Terms: '30 Days',
TotalAmount: 20800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: new Date(2014, 4, 29),
SaleAmount: 6050,
Terms: '30 Days',
TotalAmount: 6250,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: new Date(2014, 1, 6),
SaleAmount: 15850,
Terms: '30 Days',
TotalAmount: 16350,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: new Date(2013, 11, 31),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11400,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: new Date(2014, 4, 13),
SaleAmount: 13500,
Terms: '15 Days',
TotalAmount: 13800,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: new Date(2014, 0, 27),
SaleAmount: 23500,
Terms: '15 Days',
TotalAmount: 24000,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: new Date(2014, 1, 5),
SaleAmount: 2550,
Terms: '15 Days',
TotalAmount: 2625,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: new Date(2014, 2, 23),
SaleAmount: 3500,
Terms: '15 Days',
TotalAmount: 3600,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: new Date(2014, 3, 10),
SaleAmount: 10500,
Terms: '15 Days',
TotalAmount: 10900,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: new Date(2014, 2, 9),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14500,
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: new Date(2014, 0, 14),
SaleAmount: 13350,
Terms: '30 Days',
TotalAmount: 13650,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: new Date(2014, 2, 25),
SaleAmount: 8600,
Terms: '30 Days',
TotalAmount: 8850,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: new Date(2014, 3, 27),
SaleAmount: 9800,
Terms: '30 Days',
TotalAmount: 10050,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: new Date(2014, 3, 30),
SaleAmount: 10850,
Terms: '30 Days',
TotalAmount: 11100,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: new Date(2014, 1, 10),
SaleAmount: 4650,
Terms: '30 Days',
TotalAmount: 4750,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: new Date(2014, 4, 17),
SaleAmount: 2575,
Terms: '30 Days',
TotalAmount: 2625,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: new Date(2014, 3, 21),
SaleAmount: 14200,
Terms: '30 Days',
TotalAmount: 0,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: new Date(2014, 1, 14),
SaleAmount: 13650,
Terms: '30 Days',
TotalAmount: 14050,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: new Date(2014, 4, 22),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 20800,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: new Date(2014, 2, 10),
SaleAmount: 9050,
Terms: '15 Days',
TotalAmount: 9250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: new Date(2014, 0, 1),
SaleAmount: 23500,
Terms: '15 Days',
TotalAmount: 23800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: new Date(2014, 1, 8),
SaleAmount: 2100,
Terms: '15 Days',
TotalAmount: 2150,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: new Date(2014, 3, 10),
SaleAmount: 7200,
Terms: '30 Days',
TotalAmount: 7350,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: new Date(2014, 1, 11),
SaleAmount: 8750,
Terms: '30 Days',
TotalAmount: 8900,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: new Date(2014, 1, 5),
SaleAmount: 9900,
Terms: '30 Days',
TotalAmount: 10150,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: new Date(2014, 0, 21),
SaleAmount: 12800,
Terms: '30 Days',
TotalAmount: 13100,
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: new Date(2014, 2, 21),
SaleAmount: 14100,
Terms: '30 Days',
TotalAmount: 14350,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: new Date(2014, 2, 6),
SaleAmount: 4750,
Terms: '30 Days',
TotalAmount: 4950,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: new Date(2014, 4, 26),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 9250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: new Date(2014, 2, 2),
SaleAmount: 6400,
Terms: '30 Days',
TotalAmount: 6600,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: new Date(2014, 4, 9),
SaleAmount: 15700,
Terms: '30 Days',
TotalAmount: 16050,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: new Date(2014, 1, 8),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11250,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
To enable state persistence, set stateStoring.enabled to true and specify the storageKey and type properties. Depending on the type, the state can be saved to a localStorage or sessionStorage. With localStorage, the state persists across browser sessions; with sessionStorage, it is reset after the current session. This demo uses localStorage.
Alternatively, you can implement the customSave and customLoad functions to save and load the state according to custom logic. In this case, set the type property to "custom".

<div id="descContainer">Sort and filter data, group, reorder and resize columns, change page numbers and page size. Once you are done, <a onclick="window.location.reload()">refresh</a> the web page to see that the grid’s state is automatically persisted to continue working from where you stopped.</div>
<dx-data-grid id="gridContainer"
[dataSource]="orders"
[allowColumnResizing]="true"
[allowColumnReordering]="true"
[showBorders]="true"
keyExpr="ID">
<dxo-selection mode="single"></dxo-selection>
<dxo-filter-row [visible]="true"></dxo-filter-row>
<dxo-group-panel [visible]="true"></dxo-group-panel>
<dxo-state-storing [enabled]="true" type="localStorage" storageKey="storage"></dxo-state-storing>
<dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[5, 10, 20]"></dxo-pager>
<dxi-column dataField="OrderNumber" [width]="130" caption="Invoice Number"></dxi-column>
<dxi-column dataField="OrderDate" sortOrder="desc" dataType="date"></dxi-column>
<dxi-column dataField="SaleAmount" alignment="right" format="currency"></dxi-column>
<dxi-column dataField="Employee"></dxi-column>
<dxi-column dataField="CustomerStoreCity" caption="City"></dxi-column>
<dxi-column dataField="CustomerStoreState" caption="State" [groupIndex]="0"></dxi-column>
</dx-data-grid>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxDataGridModule } from 'devextreme-angular';
import { Order, Service } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
orders: Order[];
constructor(private service: Service) {
this.orders = service.getOrders()
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #gridContainer {
height: 440px;
margin-top: 30px;
}
::ng-deep #descContainer a {
color: #f05b41;
text-decoration: underline;
cursor: pointer;
}
::ng-deep #descContainer a:hover {
text-decoration: none;
}
import { Injectable } from '@angular/core';
export class Order {
ID: number;
OrderNumber: number;
OrderDate: Date;
SaleAmount: number;
Terms: string;
TotalAmount: number;
CustomerStoreState: string;
CustomerStoreCity: string;
Employee: string;
}
let orders: Order[] = [{
"ID" : 1,
"OrderNumber" : 35703,
"OrderDate" : new Date(2014, 3, 10),
"SaleAmount" : 11800,
"Terms" : "15 Days",
"TotalAmount" : 12175,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 4,
"OrderNumber" : 35711,
"OrderDate" : new Date(2014, 0, 12),
"SaleAmount" : 16050,
"Terms" : "15 Days",
"TotalAmount" : 16550,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Jose",
"Employee" : "Jim Packard"
}, {
"ID" : 5,
"OrderNumber" : 35714,
"OrderDate" : new Date(2014, 0, 22),
"SaleAmount" : 14750,
"Terms" : "15 Days",
"TotalAmount" : 15250,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 7,
"OrderNumber" : 35983,
"OrderDate" : new Date(2014, 1, 7),
"SaleAmount" : 3725,
"Terms" : "15 Days",
"TotalAmount" : 3850,
"CustomerStoreState" : "Colorado",
"CustomerStoreCity" : "Denver",
"Employee" : "Todd Hoffman"
}, {
"ID" : 9,
"OrderNumber" : 36987,
"OrderDate" : new Date(2014, 2, 11),
"SaleAmount" : 14200,
"Terms" : "15 Days",
"TotalAmount" : 14800,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 11,
"OrderNumber" : 38466,
"OrderDate" : new Date(2014, 2, 1),
"SaleAmount" : 7800,
"Terms" : "15 Days",
"TotalAmount" : 8200,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 14,
"OrderNumber" : 39420,
"OrderDate" : new Date(2014, 1, 15),
"SaleAmount" : 20500,
"Terms" : "15 Days",
"TotalAmount" : 9100,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Jose",
"Employee" : "Jim Packard"
}, {
"ID" : 15,
"OrderNumber" : 39874,
"OrderDate" : new Date(2014, 1, 4),
"SaleAmount" : 9050,
"Terms" : "30 Days",
"TotalAmount" : 19100,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 18,
"OrderNumber" : 42847,
"OrderDate" : new Date(2014, 1, 15),
"SaleAmount" : 20400,
"Terms" : "30 Days",
"TotalAmount" : 20800,
"CustomerStoreState" : "Wyoming",
"CustomerStoreCity" : "Casper",
"Employee" : "Todd Hoffman"
}, {
"ID" : 19,
"OrderNumber" : 43982,
"OrderDate" : new Date(2014, 4, 29),
"SaleAmount" : 6050,
"Terms" : "30 Days",
"TotalAmount" : 6250,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 29,
"OrderNumber" : 56272,
"OrderDate" : new Date(2014, 1, 6),
"SaleAmount" : 15850,
"Terms" : "30 Days",
"TotalAmount" : 16350,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 30,
"OrderNumber" : 57429,
"OrderDate" : new Date(2013, 11, 31),
"SaleAmount" : 11050,
"Terms" : "30 Days",
"TotalAmount" : 11400,
"CustomerStoreState" : "Arizona",
"CustomerStoreCity" : "Phoenix",
"Employee" : "Clark Morgan"
}, {
"ID" : 32,
"OrderNumber" : 58292,
"OrderDate" : new Date(2014, 4, 13),
"SaleAmount" : 13500,
"Terms" : "15 Days",
"TotalAmount" : 13800,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 36,
"OrderNumber" : 62427,
"OrderDate" : new Date(2014, 0, 27),
"SaleAmount" : 23500,
"Terms" : "15 Days",
"TotalAmount" : 24000,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 39,
"OrderNumber" : 65977,
"OrderDate" : new Date(2014, 1, 5),
"SaleAmount" : 2550,
"Terms" : "15 Days",
"TotalAmount" : 2625,
"CustomerStoreState" : "Wyoming",
"CustomerStoreCity" : "Casper",
"Employee" : "Todd Hoffman"
}, {
"ID" : 40,
"OrderNumber" : 66947,
"OrderDate" : new Date(2014, 2, 23),
"SaleAmount" : 3500,
"Terms" : "15 Days",
"TotalAmount" : 3600,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 42,
"OrderNumber" : 68428,
"OrderDate" : new Date(2014, 3, 10),
"SaleAmount" : 10500,
"Terms" : "15 Days",
"TotalAmount" : 10900,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 43,
"OrderNumber" : 69477,
"OrderDate" : new Date(2014, 2, 9),
"SaleAmount" : 14200,
"Terms" : "15 Days",
"TotalAmount" : 14500,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Anaheim",
"Employee" : "Harv Mudd"
}, {
"ID" : 46,
"OrderNumber" : 72947,
"OrderDate" : new Date(2014, 0, 14),
"SaleAmount" : 13350,
"Terms" : "30 Days",
"TotalAmount" : 13650,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 47,
"OrderNumber" : 73088,
"OrderDate" : new Date(2014, 2, 25),
"SaleAmount" : 8600,
"Terms" : "30 Days",
"TotalAmount" : 8850,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Reno",
"Employee" : "Clark Morgan"
}, {
"ID" : 50,
"OrderNumber" : 76927,
"OrderDate" : new Date(2014, 3, 27),
"SaleAmount" : 9800,
"Terms" : "30 Days",
"TotalAmount" : 10050,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 51,
"OrderNumber" : 77297,
"OrderDate" : new Date(2014, 3, 30),
"SaleAmount" : 10850,
"Terms" : "30 Days",
"TotalAmount" : 11100,
"CustomerStoreState" : "Arizona",
"CustomerStoreCity" : "Phoenix",
"Employee" : "Clark Morgan"
}, {
"ID" : 56,
"OrderNumber" : 84744,
"OrderDate" : new Date(2014, 1, 10),
"SaleAmount" : 4650,
"Terms" : "30 Days",
"TotalAmount" : 4750,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 57,
"OrderNumber" : 85028,
"OrderDate" : new Date(2014, 4, 17),
"SaleAmount" : 2575,
"Terms" : "30 Days",
"TotalAmount" : 2625,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Reno",
"Employee" : "Clark Morgan"
}, {
"ID" : 59,
"OrderNumber" : 87297,
"OrderDate" : new Date(2014, 3, 21),
"SaleAmount" : 14200,
"Terms" : "30 Days",
"TotalAmount" : 0,
"CustomerStoreState" : "Wyoming",
"CustomerStoreCity" : "Casper",
"Employee" : "Todd Hoffman"
}, {
"ID" : 60,
"OrderNumber" : 88027,
"OrderDate" : new Date(2014, 1, 14),
"SaleAmount" : 13650,
"Terms" : "30 Days",
"TotalAmount" : 14050,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 65,
"OrderNumber" : 94726,
"OrderDate" : new Date(2014, 4, 22),
"SaleAmount" : 20500,
"Terms" : "15 Days",
"TotalAmount" : 20800,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Jose",
"Employee" : "Jim Packard"
}, {
"ID" : 66,
"OrderNumber" : 95266,
"OrderDate" : new Date(2014, 2, 10),
"SaleAmount" : 9050,
"Terms" : "15 Days",
"TotalAmount" : 9250,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 69,
"OrderNumber" : 98477,
"OrderDate" : new Date(2014, 0, 1),
"SaleAmount" : 23500,
"Terms" : "15 Days",
"TotalAmount" : 23800,
"CustomerStoreState" : "Wyoming",
"CustomerStoreCity" : "Casper",
"Employee" : "Todd Hoffman"
}, {
"ID" : 70,
"OrderNumber" : 99247,
"OrderDate" : new Date(2014, 1, 8),
"SaleAmount" : 2100,
"Terms" : "15 Days",
"TotalAmount" : 2150,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 78,
"OrderNumber" : 174884,
"OrderDate" : new Date(2014, 3, 10),
"SaleAmount" : 7200,
"Terms" : "30 Days",
"TotalAmount" : 7350,
"CustomerStoreState" : "Colorado",
"CustomerStoreCity" : "Denver",
"Employee" : "Todd Hoffman"
}, {
"ID" : 81,
"OrderNumber" : 188877,
"OrderDate" : new Date(2014, 1, 11),
"SaleAmount" : 8750,
"Terms" : "30 Days",
"TotalAmount" : 8900,
"CustomerStoreState" : "Arizona",
"CustomerStoreCity" : "Phoenix",
"Employee" : "Clark Morgan"
}, {
"ID" : 82,
"OrderNumber" : 191883,
"OrderDate" : new Date(2014, 1, 5),
"SaleAmount" : 9900,
"Terms" : "30 Days",
"TotalAmount" : 10150,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 83,
"OrderNumber" : 192474,
"OrderDate" : new Date(2014, 0, 21),
"SaleAmount" : 12800,
"Terms" : "30 Days",
"TotalAmount" : 13100,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Anaheim",
"Employee" : "Harv Mudd"
}, {
"ID" : 84,
"OrderNumber" : 193847,
"OrderDate" : new Date(2014, 2, 21),
"SaleAmount" : 14100,
"Terms" : "30 Days",
"TotalAmount" : 14350,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Diego",
"Employee" : "Harv Mudd"
}, {
"ID" : 85,
"OrderNumber" : 194877,
"OrderDate" : new Date(2014, 2, 6),
"SaleAmount" : 4750,
"Terms" : "30 Days",
"TotalAmount" : 4950,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Jose",
"Employee" : "Jim Packard"
}, {
"ID" : 86,
"OrderNumber" : 195746,
"OrderDate" : new Date(2014, 4, 26),
"SaleAmount" : 9050,
"Terms" : "30 Days",
"TotalAmount" : 9250,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 87,
"OrderNumber" : 197474,
"OrderDate" : new Date(2014, 2, 2),
"SaleAmount" : 6400,
"Terms" : "30 Days",
"TotalAmount" : 6600,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Reno",
"Employee" : "Clark Morgan"
}, {
"ID" : 88,
"OrderNumber" : 198746,
"OrderDate" : new Date(2014, 4, 9),
"SaleAmount" : 15700,
"Terms" : "30 Days",
"TotalAmount" : 16050,
"CustomerStoreState" : "Colorado",
"CustomerStoreCity" : "Denver",
"Employee" : "Todd Hoffman"
}, {
"ID" : 91,
"OrderNumber" : 214222,
"OrderDate" : new Date(2014, 1, 8),
"SaleAmount" : 11050,
"Terms" : "30 Days",
"TotalAmount" : 11250,
"CustomerStoreState" : "Arizona",
"CustomerStoreCity" : "Phoenix",
"Employee" : "Clark Morgan"
}];
@Injectable()
export class Service {
getOrders() {
return orders;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.0.3/tslib.js',
'rxjs': 'npm:rxjs@6.3.3',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8',
'devextreme-angular': 'npm:devextreme-angular@20.2.4',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<div id="descContainer">Sort and filter data, group, reorder and resize columns,
change page numbers and page size. Once you are done, <a @click="onRefreshClick">refresh</a>
the web page to see that the grid’s state is automatically persisted to continue working from
where you stopped or you can <a @click="onStateResetClick">reset</a>
the grid to its initial state.</div>
<DxDataGrid
id="gridContainer"
ref="dataGrid"
:data-source="orders"
:allow-column-resizing="true"
:allow-column-reordering="true"
:show-borders="true"
key-expr="ID"
>
<DxSelection mode="single"/>
<DxFilterRow :visible="true"/>
<DxGroupPanel :visible="true"/>
<DxStateStoring
:enabled="true"
type="localStorage"
storage-key="storage"
/>
<DxPager
:show-page-size-selector="true"
:allowed-page-sizes="[5, 10, 20]"
/>
<DxColumn
:width="130"
data-field="OrderNumber"
caption="Invoice Number"
/>
<DxColumn
data-field="OrderDate"
sort-order="desc"
data-type="date"
/>
<DxColumn
data-field="SaleAmount"
alignment="right"
format="currency"
/>
<DxColumn data-field="Employee"/>
<DxColumn
data-field="CustomerStoreCity"
caption="City"
/>
<DxColumn
:group-index="0"
data-field="CustomerStoreState"
caption="State"
/>
</DxDataGrid>
</div>
</template>
<script>
import {
DxDataGrid, DxSelection, DxFilterRow, DxGroupPanel, DxStateStoring, DxPager, DxColumn,
} from 'devextreme-vue/data-grid';
import service from './data.js';
export default {
components: {
DxDataGrid, DxSelection, DxFilterRow, DxGroupPanel, DxStateStoring, DxPager, DxColumn,
},
data() {
return {
orders: service.getOrders(),
};
},
methods: {
onRefreshClick() {
window.location.reload();
},
onStateResetClick() {
this.$refs.dataGrid.instance.state(null);
},
},
};
</script>
<style scoped>
#gridContainer {
height: 440px;
margin-top: 30px;
}
#descContainer a {
color: #f05b41;
text-decoration: underline;
cursor: pointer;
}
#descContainer a:hover {
text-decoration: none;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>
const orders = [{
ID: 1,
OrderNumber: 35703,
OrderDate: new Date(2014, 3, 10),
SaleAmount: 11800,
Terms: '15 Days',
TotalAmount: 12175,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: new Date(2014, 0, 12),
SaleAmount: 16050,
Terms: '15 Days',
TotalAmount: 16550,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: new Date(2014, 0, 22),
SaleAmount: 14750,
Terms: '15 Days',
TotalAmount: 15250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: new Date(2014, 1, 7),
SaleAmount: 3725,
Terms: '15 Days',
TotalAmount: 3850,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: new Date(2014, 2, 11),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14800,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: new Date(2014, 2, 1),
SaleAmount: 7800,
Terms: '15 Days',
TotalAmount: 8200,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: new Date(2014, 1, 15),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 9100,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: new Date(2014, 1, 4),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 19100,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: new Date(2014, 1, 15),
SaleAmount: 20400,
Terms: '30 Days',
TotalAmount: 20800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: new Date(2014, 4, 29),
SaleAmount: 6050,
Terms: '30 Days',
TotalAmount: 6250,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: new Date(2014, 1, 6),
SaleAmount: 15850,
Terms: '30 Days',
TotalAmount: 16350,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: new Date(2013, 11, 31),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11400,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 32,
OrderNumber: 58292,
OrderDate: new Date(2014, 4, 13),
SaleAmount: 13500,
Terms: '15 Days',
TotalAmount: 13800,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 36,
OrderNumber: 62427,
OrderDate: new Date(2014, 0, 27),
SaleAmount: 23500,
Terms: '15 Days',
TotalAmount: 24000,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 39,
OrderNumber: 65977,
OrderDate: new Date(2014, 1, 5),
SaleAmount: 2550,
Terms: '15 Days',
TotalAmount: 2625,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 40,
OrderNumber: 66947,
OrderDate: new Date(2014, 2, 23),
SaleAmount: 3500,
Terms: '15 Days',
TotalAmount: 3600,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 42,
OrderNumber: 68428,
OrderDate: new Date(2014, 3, 10),
SaleAmount: 10500,
Terms: '15 Days',
TotalAmount: 10900,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 43,
OrderNumber: 69477,
OrderDate: new Date(2014, 2, 9),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14500,
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 46,
OrderNumber: 72947,
OrderDate: new Date(2014, 0, 14),
SaleAmount: 13350,
Terms: '30 Days',
TotalAmount: 13650,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 47,
OrderNumber: 73088,
OrderDate: new Date(2014, 2, 25),
SaleAmount: 8600,
Terms: '30 Days',
TotalAmount: 8850,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 50,
OrderNumber: 76927,
OrderDate: new Date(2014, 3, 27),
SaleAmount: 9800,
Terms: '30 Days',
TotalAmount: 10050,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 51,
OrderNumber: 77297,
OrderDate: new Date(2014, 3, 30),
SaleAmount: 10850,
Terms: '30 Days',
TotalAmount: 11100,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 56,
OrderNumber: 84744,
OrderDate: new Date(2014, 1, 10),
SaleAmount: 4650,
Terms: '30 Days',
TotalAmount: 4750,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 57,
OrderNumber: 85028,
OrderDate: new Date(2014, 4, 17),
SaleAmount: 2575,
Terms: '30 Days',
TotalAmount: 2625,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 59,
OrderNumber: 87297,
OrderDate: new Date(2014, 3, 21),
SaleAmount: 14200,
Terms: '30 Days',
TotalAmount: 0,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 60,
OrderNumber: 88027,
OrderDate: new Date(2014, 1, 14),
SaleAmount: 13650,
Terms: '30 Days',
TotalAmount: 14050,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 65,
OrderNumber: 94726,
OrderDate: new Date(2014, 4, 22),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 20800,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 66,
OrderNumber: 95266,
OrderDate: new Date(2014, 2, 10),
SaleAmount: 9050,
Terms: '15 Days',
TotalAmount: 9250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 69,
OrderNumber: 98477,
OrderDate: new Date(2014, 0, 1),
SaleAmount: 23500,
Terms: '15 Days',
TotalAmount: 23800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 70,
OrderNumber: 99247,
OrderDate: new Date(2014, 1, 8),
SaleAmount: 2100,
Terms: '15 Days',
TotalAmount: 2150,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 78,
OrderNumber: 174884,
OrderDate: new Date(2014, 3, 10),
SaleAmount: 7200,
Terms: '30 Days',
TotalAmount: 7350,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 81,
OrderNumber: 188877,
OrderDate: new Date(2014, 1, 11),
SaleAmount: 8750,
Terms: '30 Days',
TotalAmount: 8900,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
ID: 82,
OrderNumber: 191883,
OrderDate: new Date(2014, 1, 5),
SaleAmount: 9900,
Terms: '30 Days',
TotalAmount: 10150,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 83,
OrderNumber: 192474,
OrderDate: new Date(2014, 0, 21),
SaleAmount: 12800,
Terms: '30 Days',
TotalAmount: 13100,
CustomerStoreState: 'California',
CustomerStoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
ID: 84,
OrderNumber: 193847,
OrderDate: new Date(2014, 2, 21),
SaleAmount: 14100,
Terms: '30 Days',
TotalAmount: 14350,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
ID: 85,
OrderNumber: 194877,
OrderDate: new Date(2014, 2, 6),
SaleAmount: 4750,
Terms: '30 Days',
TotalAmount: 4950,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 86,
OrderNumber: 195746,
OrderDate: new Date(2014, 4, 26),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 9250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 87,
OrderNumber: 197474,
OrderDate: new Date(2014, 2, 2),
SaleAmount: 6400,
Terms: '30 Days',
TotalAmount: 6600,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
ID: 88,
OrderNumber: 198746,
OrderDate: new Date(2014, 4, 9),
SaleAmount: 15700,
Terms: '30 Days',
TotalAmount: 16050,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 91,
OrderNumber: 214222,
OrderDate: new Date(2014, 1, 8),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11250,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
export default {
getOrders() {
return orders;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.41/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

import React from 'react';
import DataGrid, { Selection, FilterRow, GroupPanel, StateStoring, Pager, Column } from 'devextreme-react/data-grid';
import service from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.orders = service.getOrders();
}
onRefreshClick() {
window.location.reload();
}
render() {
return (
<React.Fragment>
<div id="descContainer">Sort and filter data, group, reorder and resize columns, change page numbers and page size. Once you are done, <a onClick={this.onRefreshClick}>refresh</a> the web page to see that the grid’s state is automatically persisted to continue working from where you stopped.</div>
<DataGrid
id="gridContainer"
dataSource={this.orders}
allowColumnResizing={true}
allowColumnReordering={true}
showBorders={true}
keyExpr="ID">
<Selection mode="single" />
<FilterRow visible={true} />
<GroupPanel visible={true} />
<StateStoring enabled={true} type="localStorage" storageKey="storage" />
<Pager showPageSizeSelector={true} allowedPageSizes={[5, 10, 20]} />
<Column dataField="OrderNumber" caption="Invoice Number" width={130} />
<Column dataField="OrderDate" sortOrder="desc" dataType="date" />
<Column dataField="SaleAmount" alignment="right" format="currency" />
<Column dataField="Employee" />
<Column dataField="CustomerStoreCity" caption="City" />
<Column dataField="CustomerStoreState" caption="State" groupIndex={0} />
</DataGrid>
</React.Fragment>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer {
height: 440px;
margin-top: 30px;
}
#descContainer a {
color: #f05b41;
text-decoration: underline;
cursor: pointer;
}
#descContainer a:hover {
text-decoration: none;
}
let orders = [{
'ID' : 1,
'OrderNumber' : 35703,
'OrderDate' : new Date(2014, 3, 10),
'SaleAmount' : 11800,
'Terms' : '15 Days',
'TotalAmount' : 12175,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Los Angeles',
'Employee' : 'Harv Mudd'
}, {
'ID' : 4,
'OrderNumber' : 35711,
'OrderDate' : new Date(2014, 0, 12),
'SaleAmount' : 16050,
'Terms' : '15 Days',
'TotalAmount' : 16550,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'San Jose',
'Employee' : 'Jim Packard'
}, {
'ID' : 5,
'OrderNumber' : 35714,
'OrderDate' : new Date(2014, 0, 22),
'SaleAmount' : 14750,
'Terms' : '15 Days',
'TotalAmount' : 15250,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 7,
'OrderNumber' : 35983,
'OrderDate' : new Date(2014, 1, 7),
'SaleAmount' : 3725,
'Terms' : '15 Days',
'TotalAmount' : 3850,
'CustomerStoreState' : 'Colorado',
'CustomerStoreCity' : 'Denver',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 9,
'OrderNumber' : 36987,
'OrderDate' : new Date(2014, 2, 11),
'SaleAmount' : 14200,
'Terms' : '15 Days',
'TotalAmount' : 14800,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 11,
'OrderNumber' : 38466,
'OrderDate' : new Date(2014, 2, 1),
'SaleAmount' : 7800,
'Terms' : '15 Days',
'TotalAmount' : 8200,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Los Angeles',
'Employee' : 'Harv Mudd'
}, {
'ID' : 14,
'OrderNumber' : 39420,
'OrderDate' : new Date(2014, 1, 15),
'SaleAmount' : 20500,
'Terms' : '15 Days',
'TotalAmount' : 9100,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'San Jose',
'Employee' : 'Jim Packard'
}, {
'ID' : 15,
'OrderNumber' : 39874,
'OrderDate' : new Date(2014, 1, 4),
'SaleAmount' : 9050,
'Terms' : '30 Days',
'TotalAmount' : 19100,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 18,
'OrderNumber' : 42847,
'OrderDate' : new Date(2014, 1, 15),
'SaleAmount' : 20400,
'Terms' : '30 Days',
'TotalAmount' : 20800,
'CustomerStoreState' : 'Wyoming',
'CustomerStoreCity' : 'Casper',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 19,
'OrderNumber' : 43982,
'OrderDate' : new Date(2014, 4, 29),
'SaleAmount' : 6050,
'Terms' : '30 Days',
'TotalAmount' : 6250,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 29,
'OrderNumber' : 56272,
'OrderDate' : new Date(2014, 1, 6),
'SaleAmount' : 15850,
'Terms' : '30 Days',
'TotalAmount' : 16350,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 30,
'OrderNumber' : 57429,
'OrderDate' : new Date(2013, 11, 31),
'SaleAmount' : 11050,
'Terms' : '30 Days',
'TotalAmount' : 11400,
'CustomerStoreState' : 'Arizona',
'CustomerStoreCity' : 'Phoenix',
'Employee' : 'Clark Morgan'
}, {
'ID' : 32,
'OrderNumber' : 58292,
'OrderDate' : new Date(2014, 4, 13),
'SaleAmount' : 13500,
'Terms' : '15 Days',
'TotalAmount' : 13800,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Los Angeles',
'Employee' : 'Harv Mudd'
}, {
'ID' : 36,
'OrderNumber' : 62427,
'OrderDate' : new Date(2014, 0, 27),
'SaleAmount' : 23500,
'Terms' : '15 Days',
'TotalAmount' : 24000,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 39,
'OrderNumber' : 65977,
'OrderDate' : new Date(2014, 1, 5),
'SaleAmount' : 2550,
'Terms' : '15 Days',
'TotalAmount' : 2625,
'CustomerStoreState' : 'Wyoming',
'CustomerStoreCity' : 'Casper',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 40,
'OrderNumber' : 66947,
'OrderDate' : new Date(2014, 2, 23),
'SaleAmount' : 3500,
'Terms' : '15 Days',
'TotalAmount' : 3600,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 42,
'OrderNumber' : 68428,
'OrderDate' : new Date(2014, 3, 10),
'SaleAmount' : 10500,
'Terms' : '15 Days',
'TotalAmount' : 10900,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Los Angeles',
'Employee' : 'Harv Mudd'
}, {
'ID' : 43,
'OrderNumber' : 69477,
'OrderDate' : new Date(2014, 2, 9),
'SaleAmount' : 14200,
'Terms' : '15 Days',
'TotalAmount' : 14500,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Anaheim',
'Employee' : 'Harv Mudd'
}, {
'ID' : 46,
'OrderNumber' : 72947,
'OrderDate' : new Date(2014, 0, 14),
'SaleAmount' : 13350,
'Terms' : '30 Days',
'TotalAmount' : 13650,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 47,
'OrderNumber' : 73088,
'OrderDate' : new Date(2014, 2, 25),
'SaleAmount' : 8600,
'Terms' : '30 Days',
'TotalAmount' : 8850,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Reno',
'Employee' : 'Clark Morgan'
}, {
'ID' : 50,
'OrderNumber' : 76927,
'OrderDate' : new Date(2014, 3, 27),
'SaleAmount' : 9800,
'Terms' : '30 Days',
'TotalAmount' : 10050,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 51,
'OrderNumber' : 77297,
'OrderDate' : new Date(2014, 3, 30),
'SaleAmount' : 10850,
'Terms' : '30 Days',
'TotalAmount' : 11100,
'CustomerStoreState' : 'Arizona',
'CustomerStoreCity' : 'Phoenix',
'Employee' : 'Clark Morgan'
}, {
'ID' : 56,
'OrderNumber' : 84744,
'OrderDate' : new Date(2014, 1, 10),
'SaleAmount' : 4650,
'Terms' : '30 Days',
'TotalAmount' : 4750,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 57,
'OrderNumber' : 85028,
'OrderDate' : new Date(2014, 4, 17),
'SaleAmount' : 2575,
'Terms' : '30 Days',
'TotalAmount' : 2625,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Reno',
'Employee' : 'Clark Morgan'
}, {
'ID' : 59,
'OrderNumber' : 87297,
'OrderDate' : new Date(2014, 3, 21),
'SaleAmount' : 14200,
'Terms' : '30 Days',
'TotalAmount' : 0,
'CustomerStoreState' : 'Wyoming',
'CustomerStoreCity' : 'Casper',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 60,
'OrderNumber' : 88027,
'OrderDate' : new Date(2014, 1, 14),
'SaleAmount' : 13650,
'Terms' : '30 Days',
'TotalAmount' : 14050,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 65,
'OrderNumber' : 94726,
'OrderDate' : new Date(2014, 4, 22),
'SaleAmount' : 20500,
'Terms' : '15 Days',
'TotalAmount' : 20800,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'San Jose',
'Employee' : 'Jim Packard'
}, {
'ID' : 66,
'OrderNumber' : 95266,
'OrderDate' : new Date(2014, 2, 10),
'SaleAmount' : 9050,
'Terms' : '15 Days',
'TotalAmount' : 9250,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 69,
'OrderNumber' : 98477,
'OrderDate' : new Date(2014, 0, 1),
'SaleAmount' : 23500,
'Terms' : '15 Days',
'TotalAmount' : 23800,
'CustomerStoreState' : 'Wyoming',
'CustomerStoreCity' : 'Casper',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 70,
'OrderNumber' : 99247,
'OrderDate' : new Date(2014, 1, 8),
'SaleAmount' : 2100,
'Terms' : '15 Days',
'TotalAmount' : 2150,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 78,
'OrderNumber' : 174884,
'OrderDate' : new Date(2014, 3, 10),
'SaleAmount' : 7200,
'Terms' : '30 Days',
'TotalAmount' : 7350,
'CustomerStoreState' : 'Colorado',
'CustomerStoreCity' : 'Denver',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 81,
'OrderNumber' : 188877,
'OrderDate' : new Date(2014, 1, 11),
'SaleAmount' : 8750,
'Terms' : '30 Days',
'TotalAmount' : 8900,
'CustomerStoreState' : 'Arizona',
'CustomerStoreCity' : 'Phoenix',
'Employee' : 'Clark Morgan'
}, {
'ID' : 82,
'OrderNumber' : 191883,
'OrderDate' : new Date(2014, 1, 5),
'SaleAmount' : 9900,
'Terms' : '30 Days',
'TotalAmount' : 10150,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Los Angeles',
'Employee' : 'Harv Mudd'
}, {
'ID' : 83,
'OrderNumber' : 192474,
'OrderDate' : new Date(2014, 0, 21),
'SaleAmount' : 12800,
'Terms' : '30 Days',
'TotalAmount' : 13100,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Anaheim',
'Employee' : 'Harv Mudd'
}, {
'ID' : 84,
'OrderNumber' : 193847,
'OrderDate' : new Date(2014, 2, 21),
'SaleAmount' : 14100,
'Terms' : '30 Days',
'TotalAmount' : 14350,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'San Diego',
'Employee' : 'Harv Mudd'
}, {
'ID' : 85,
'OrderNumber' : 194877,
'OrderDate' : new Date(2014, 2, 6),
'SaleAmount' : 4750,
'Terms' : '30 Days',
'TotalAmount' : 4950,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'San Jose',
'Employee' : 'Jim Packard'
}, {
'ID' : 86,
'OrderNumber' : 195746,
'OrderDate' : new Date(2014, 4, 26),
'SaleAmount' : 9050,
'Terms' : '30 Days',
'TotalAmount' : 9250,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 87,
'OrderNumber' : 197474,
'OrderDate' : new Date(2014, 2, 2),
'SaleAmount' : 6400,
'Terms' : '30 Days',
'TotalAmount' : 6600,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Reno',
'Employee' : 'Clark Morgan'
}, {
'ID' : 88,
'OrderNumber' : 198746,
'OrderDate' : new Date(2014, 4, 9),
'SaleAmount' : 15700,
'Terms' : '30 Days',
'TotalAmount' : 16050,
'CustomerStoreState' : 'Colorado',
'CustomerStoreCity' : 'Denver',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 91,
'OrderNumber' : 214222,
'OrderDate' : new Date(2014, 1, 8),
'SaleAmount' : 11050,
'Terms' : '30 Days',
'TotalAmount' : 11250,
'CustomerStoreState' : 'Arizona',
'CustomerStoreCity' : 'Phoenix',
'Employee' : 'Clark Morgan'
}];
export default {
getOrders() {
return orders;
}
};
System.config({
transpiler: 'plugin-babel',
meta: {
},
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16.14.0/umd/react.development.js',
'react-dom': 'npm:react-dom@16.14.0/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.7.2/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'devextreme-react': 'npm:devextreme-react@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});